// MotorCommands.h
/* Sam Bobb,  Daniel Cornew,  Ryan Deeter
	Two degree of freedom arm
	High speed motor control for 2 motors
	Code version 3
	March 18, 2010
	

*/

#ifndef __MOTORCOMMANDS_H
#define __MOTORCOMMANDS_H

// --- Declarations ---
void motor_break();
void motor_float();
void motor_run();


// --- Definitions ---

void motor_break()
{
	runcontrol = FALSE;
	
	ENABLE_M1 = 1; // Enable Motor 1
	ENABLE_M2 = 1; // Enable Motor 2
	
	// set direction and PWM pin to opposits to break
	DIRECTION_M1 = 0;
	SetDCOC1PWM(0);
	DIRECTION_M2 = 0;
	SetDCOC2PWM(0);
	
	mLED_3_Off();
}

void motor_float()
{
	runcontrol = FALSE;
	
	// set enable to 0 to float the motor
	ENABLE_M1 = 0; // Enable Motor 1
	ENABLE_M2 = 0; // Enable Motor 2
	mLED_3_Off();
}

void motor_run()
{
	ENABLE_M1 = 1; // Enable Motor 1
	ENABLE_M2 = 1; // Enable Motor 2
	runcontrol = TRUE;
	mLED_3_On();
}

void setPWMandDirection(signed int M1signedPWM, signed int M2signedPWM)
{
	//unsigned int pwmMagn;
	
	//pwmMagn = getPWMmagn(error);
	
	// Motor 1 (flipped from clockwise positive convention)
	if (M1signedPWM > 0) 					// Go Reverse r > y
	{
		DIRECTION_M1 = REVERSE;
        SetDCOC1PWM(MAX_RESOLUTION - M1signedPWM);
	}
	else						// Go Forward r < y
	{
		DIRECTION_M1 = FORWARD;
		SetDCOC1PWM(-M1signedPWM);
	}


	// Motor 2
	if (M2signedPWM > 0) 					// Go Forward r > y
	{
		DIRECTION_M2 = FORWARD;
        SetDCOC2PWM(M2signedPWM);
	}
	else						// Go Reverse r < y
	{
		DIRECTION_M2 = REVERSE;
		SetDCOC2PWM(MAX_RESOLUTION + M2signedPWM);
	}
	
	
}


#endif
